*+--------------------------------------------------------------------
*+
*+ Source Module => c:\hmg.3.4.4\0\CPU\\MCPU.PRG
*+
*+    Copyright(C) 1983-2021 by Auge & Ohr
*+
*+    Functions: Procedure Main()
*+               Static Procedure CreateForms()
*+               Procedure Wait4Action()
*+               Static Function Paint_Background_Window()
*+               Static Function RandPoint()
*+               Static Function RandColor()
*+               Static Procedure HideShow()
*+               Static Function DoRelease()
*+               Static Function GetDesktopArea()
*+               Static Function SmpGetCPU()
*+               Static Function SmpSetCPU()
*+               Static Procedure Stress()
*+               Static Function GetCurrentProcess()
*+               Static Function GetProcessAffinityMask()
*+               Static Function SetProcessAffinityMask()
*+               Static Procedure switchcpu()
*+               Static Function Mask2CPU()
*+               Static Function CHECKCPU()
*+               Static Function IsWinXPHome()
*+               Static Procedure OnDummy()
*+               Static Function VAR2CHAR()
*+               Static Function RandomInt()
*+
*+    Reformatted by Click! 2.05.38 on Aug-29-2021 at  1:48 pm
*+
*+--------------------------------------------------------------------

#include "HMG.ch"
#include "hbclass.ch"
#include "dll.ch"
#include "common.ch"
#include "hbthread.ch"

#include "i_color.ch"
#include "FRACTAL.CH"

#define MB_OK                 0x00000000
#define MB_ICONEXCLAMATION    0x00000030
#define CRLF                  CHR(13)+CHR(10)

#define TRIM_NUMBER(x)        LTRIM(STR(x))

#xtranslate IsWinNT()    =>    os_IsWinNT()
#xtranslate DllCall     =>    HMG_CallDLL

#ifdef __XHARBOUR__
#define ENUMINDEX hb_EnumIndex()
#else
#define ENUMINDEX enum:__EnumIndex
#endif

STATIC a_Forms := {}

MEMVAR _HMG_SYSDATA
MEMVAR aThread, lRunning

*+--------------------------------------------------------------------
*+
*+    Procedure Main()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Main()

LOCAL nMax     := CHECKCPU()
PUBLIC aThread, lRunning := .T.

   SET ALTER TO "_LOG.TXT"
   SET ALTER ON

   SET MULTIPLE OFF

   DEFINE WINDOW Form_1 ;
         AT 0, 0 ;
         WIDTH 0 HEIGHT 0 ;
         TITLE "CPU Demo" ;
         ICON 'MAIN' ;
         MAIN ;
         ON INIT CreateForms() ;
         ON RELEASE DoRelease() ;
         NOTIFYICON 'MAIN' ;
         NOTIFYTOOLTIP "CPU Demo" ;
         NOSHOW ;
         ON NOTIFYCLICK HideShow()

      DEFINE NOTIFY MENU OF Form_1
         ITEM '&Exit' ACTION { || lRunning := .F., Form_1.Release }
      END MENU

      IF PCOUNT() > 0
         DEFINE TIMER Timer_1 OF Form_1 INTERVAL 333 ACTION switchcpu( nMax )
      ENDIF

   END WINDOW

   ACTIVATE WINDOW Form_1

   hb_threadTerminateAll()

   SET ALTER OFF
   SET ALTER TO

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure CreateForms()
*+
*+    Called from ( mcpu.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE CreateForms()

LOCAL aDesk       := GetDesktopArea()
LOCAL nDeskWidth  := aDesk[ 3 ] - aDesk[ 1 ]
LOCAL nDeskHeight := aDesk[ 4 ] - aDesk[ 2 ]
LOCAL nTop        := 0
LOCAL nLeft       := 0
LOCAL nMaxRow     := 0
LOCAL nMaxCol     := 0
LOCAL nRow        := 0
LOCAL nOffSet     := 20
LOCAL wide        := 0
LOCAL height      := 0
LOCAL Tbar        := 50                                               // GetTaskBarHeight()
LOCAL i, iMax
LOCAL cForm

   nDeskHeight -= Tbar

   iMax := CHECKCPU()
   DO CASE
      CASE iMax = 4
         nMaxRow := 2
         nMaxCol := 2
      CASE iMax = 6
         nMaxRow := 2
         nMaxCol := 3
      CASE iMax = 8
         nMaxRow := 2
         nMaxCol := 4
      CASE iMax = 12
         nMaxCol := 4
         nMaxRow := 3
      CASE iMax = 16
         nMaxRow := 4
         nMaxCol := 4
      CASE iMax = 32
         nMaxRow := 4
         nMaxCol := 8
   ENDCASE

   wide := nDeskWidth / nMaxCol
   height := nDeskHeight / nMaxRow
   nOffSet := 200 / nMaxCol

   wide -= nOffSet

   aThread := ARRAY( iMax )

   FOR i = 1 TO iMax
      cForm := "Form_" + STRZERO( i, 2 )

      DEFINE WINDOW &cForm ;
            AT nTop, nLeft ;
            WIDTH wide + 3 ;
            HEIGHT height + 3 ;
            CHILD ;
            TOPMOST ;
            NOSHOW ;
            NOCAPTION ;
            ON PAINT nil ;
            BACKCOLOR BLACK ;
            ON RELEASE DoRelease()  ;
            NOMINIMIZE NOMAXIMIZE NOSIZE
      END WINDOW

      ThisWindow.NoClose := .T.

      AADD( a_Forms, "Form_" + STRZERO( i, 2 ) )

      nLeft += wide

      IF nLeft > nDeskWidth - ( iMax * nOffSet )
         nLeft := 0
         nRow ++
         nTop := nDeskHeight - ( height * nRow )
      ENDIF

   NEXT

   _ActivateWindow( a_Forms, .F. )

   HideShow()
   FOR i = 1 TO iMax
      cForm := a_Forms[ i ]
      aThread[ i ] := hb_threadStart( HB_BITOR( HB_THREAD_INHERIT_PUBLIC, HB_THREAD_MEMVARS_COPY ), @Wait4Action(), cForm, STR( i ), wide, height )
      DO EVENTS
      hb_idleSleep( 0.3 )
   NEXT

RETURN

*+--------------------------------------------------------------------
*+
*+    Procedure Wait4Action()
*+
*+    Called from ( mcpu.prg )   1 - static procedure createforms()
*+
*+--------------------------------------------------------------------
*+
PROCEDURE Wait4Action( cForm, cID, nwide, nheight )

   DO WHILE lRunning = .T.
      ERASE WINDOW &cForm
      Paint_Background_Window( cForm, cID, nwide, nheight )
      //    Stress()
      DO EVENTS
   ENDDO
   DoMethod( cForm,"Release" )

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Procedure Stress()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE Stress()

LOCAL a := { 3, 2, 1, 0 }
   //  DO WHILE .T.
   ASORT( a )
   //  ENDDO
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function Paint_Background_Window()
*+
*+    Called from ( mcpu.prg )   1 - procedure wait4action()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Paint_Background_Window( cForm, cID, nwide, nheight )

LOCAL aEdges, TmpEdge, NewPoint, k, n, i
LOCAL bOldError

   bOldError := ERRORBLOCK( { | e | BREAK( e ) } )
   BEGIN SEQUENCE

   // Drei Punkte im CRT Fenster bilden ein Dreieck
   aEdges := ARRAY( NUM_EDGE )
   //   AEval( aEdges, { |e| e:=RandPoint( nwide, nheight ) }, , , .T. )
   FOR i := 1 TO NUM_EDGE
      aEdges[ i ] := RandPoint( nwide, nheight )
   NEXT

   FOR i := 1 TO NUM_EDGE
      NewPoint := ACLONE( aEdges[ i ] )

      DRAW LINE IN WINDOW &cForm ;
              AT NewPoint[ 1 ], NewPoint[ 2 ] ;
              TO NewPoint[ 1 ], NewPoint[ 2 ] ;
              PENCOLOR RandColor() PENWIDTH 2

   NEXT

   FOR n := 1 TO NUM_POINTS
      // Zufllig einen Punkt des Dreiecks auswhlen
      i := RandomInt( 1, NUM_EDGE )
      IF EMPTY( i )
         i := 1
      ENDIF
      TmpEdge := aEdges[ i ]
      // Der neue Punkt liegt auf der Hlfte der Strecke
      // des Start Punktes und einer Dreiecks Ecke
      NewPoint[ 1 ] := ( TmpEdge[ 1 ] + NewPoint[ 1 ] ) / 2
      NewPoint[ 2 ] := ( TmpEdge[ 2 ] + NewPoint[ 2 ] ) / 2
      // Punkt zeichnen
      DRAW LINE IN WINDOW &cForm ;
              AT NewPoint[ 1 ], NewPoint[ 2 ] ;
              TO NewPoint[ 1 ], NewPoint[ 2 ] ;
              PENCOLOR RandColor() PENWIDTH 2

   NEXT

   END SEQUENCE
   ERRORBLOCK( bOldError )

RETURN nil

*+--------------------------------------------------------------------
*+
*+    Static Function RandPoint()
*+
*+    Called from ( mcpu.prg )   1 - static function paint_background_window()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION RandPoint( nwide, nheight )

RETURN { RandomInt( 0, nwide ), RandomInt( 0, nheight ) }

*+--------------------------------------------------------------------
*+
*+    Static Function RandColor()
*+
*+    Called from ( mcpu.prg )   1 - static function paint_background_window()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION RandColor()

LOCAL nColor
   nColor := { RandomInt( 0, 255 ), ;
               RandomInt( 0, 255 ), ;
               RandomInt( 0, 255 ) }

RETURN nColor

*+--------------------------------------------------------------------
*+
*+    Static Procedure HideShow()
*+
*+    Called from ( mcpu.prg )   1 - procedure main()
*+                                   1 - static procedure createforms()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE HideShow()

LOCAL enum

   IF IsWindowVisible( GetFormHandle( "Form_1" ) )
      lBusy := .F.
      FOR EACH enum IN a_Forms
         DoMethod( "Form_" + STRZERO( ENUMINDEX, 2 ), "Hide" )
      NEXT
   ELSE
      lBusy := .T.
      FOR EACH enum IN a_Forms
         DoMethod( "Form_" + STRZERO( ENUMINDEX, 2 ), "Show" )
      NEXT
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function DoRelease()
*+
*+    Called from ( mcpu.prg )   1 - procedure main()
*+                                   1 - static procedure createforms()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION DoRelease()

   lRunning := .F.
RETURN NIL

*+--------------------------------------------------------------------
*+
*+    Static Function GetDesktopArea()
*+
*+    Called from ( mcpu.prg )   1 - static procedure createforms()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION GetDesktopArea()

LOCAL aDesk := { 0, 0, 0, 0 }
   aDesk[ 3 ] := GetDesktopWidth()
   aDesk[ 4 ] := GetDesktopHeight()
RETURN aDesk

*+--------------------------------------------------------------------
*+
*+    Static Function SmpGetCPU()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION SmpGetCPU( ProcMask, SysMask )

LOCAL i
   GetProcessAffinityMask( @ProcMask, @SysMask )
   i := Mask2CPU( ProcMask )
RETURN -- i

*+--------------------------------------------------------------------
*+
*+    Static Function SmpSetCPU()
*+
*+    Called from ( mcpu.prg )   2 - static procedure switchcpu()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION SmpSetCPU( nCpuMask )

LOCAL rc
   nCpuMask := INT( nCpuMask )
   rc := SetProcessAffinityMask( nCpuMask )
RETURN rc

*+--------------------------------------------------------------------
*+
*+    Static Function GetCurrentProcess()
*+
*+    Called from ( mcpu.prg )   1 - static function getprocessaffinitymask()
*+                                   1 - static function setprocessaffinitymask()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION GetCurrentProcess()

LOCAL rc := 0
   rc := dllcall( "Kernel32.dll",, "GetCurrentProcess" )
RETURN rc

*+--------------------------------------------------------------------
*+
*+    Static Function GetProcessAffinityMask()
*+
*+    Called from ( mcpu.prg )   1 - static function smpgetcpu()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION GetProcessAffinityMask( ProcMask, SysMask )

LOCAL rc        := 0
LOCAL ip        := 0
LOCAL bOldError

   bOldError := ERRORBLOCK( { | e | BREAK( e ) } )
   BEGIN SEQUENCE
      ip := GetCurrentProcess()
      rc := dllcall( "Kernel32.dll", DLL_OSAPI, "GetProcessAffinityMask", ip, @ProcMask, @SysMask )
   END SEQUENCE
   ERRORBLOCK( bOldError )

   IF EMPTY( rc )
      DllCall( "user32.dll", DLL_OSAPI, "MessageBoxA", 0, "Error GetProcessAffinityMask" + STR( ProcMask ) + STR( GetLastError() ), "Invalid parameter", hb_bitOr( MB_OK, MB_ICONEXCLAMATION ) )
      OnDummy( "Error GetProcessAffinityMask" + STR( ProcMask ) + STR( GetLastError() ), "Invalid parameter" )
      rc := 0
   ENDIF
RETURN rc

*+--------------------------------------------------------------------
*+
*+    Static Function SetProcessAffinityMask()
*+
*+    Called from ( mcpu.prg )   1 - static function smpsetcpu()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION SetProcessAffinityMask( nProc )

LOCAL rc        := 0
LOCAL ip        := 0
LOCAL bOldError

   bOldError := ERRORBLOCK( { | e | BREAK( e ) } )
   BEGIN SEQUENCE
      ip := GetCurrentProcess()
      rc := dllcall( "Kernel32.dll", DLL_OSAPI, "SetProcessAffinityMask", ip, nProc )
   END SEQUENCE
   ERRORBLOCK( bOldError )

   IF EMPTY( rc )
      DllCall( "user32.dll", DLL_OSAPI, "MessageBoxA", 0, "Error SetProcessAffinityMask" + STR( nProc ) + STR( GetLastError() ), "Invalid parameter", hb_bitOr( MB_OK, MB_ICONEXCLAMATION ) )
      OnDummy( "Error SetProcessAffinityMask" + STR( nProc ) + STR( GetLastError() ), "Invalid parameter" )
      rc := 0
   ENDIF

RETURN rc

*+--------------------------------------------------------------------
*+
*+    Static Procedure switchcpu()
*+
*+    Called from ( mcpu.prg )   1 - procedure main()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE switchcpu( nMax )

LOCAL nWorkCPU
LOCAL ProcMask := 0
LOCAL SysMask  := 0

STATIC nStep := 1

   DEFAULT nMax TO 1

   nStep ++
   IF nStep > nMax
      nStep := 1
   ENDIF

   IF nStep = 1
      SmpSetCPU( 1 )
   ELSE
      nWorkCPU := 2 ^ INT( nStep - 1 )
      SmpSetCPU( nWorkCPU )
   ENDIF

RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function Mask2CPU()
*+
*+    Called from ( mcpu.prg )   1 - static function smpgetcpu()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION Mask2CPU( nMask )

LOCAL nCPU  := 1
LOCAL nRest := nMask

   DO WHILE nRest >= 1
      nRest := nRest / 2
      nCPU ++
   ENDDO

RETURN nCPU

*+--------------------------------------------------------------------
*+
*+    Static Function CHECKCPU()
*+
*+    Called from ( mcpu.prg )   1 - procedure main()
*+                                   1 - static procedure createforms()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION CHECKCPU()

LOCAL oWmi, oProc
LOCAL nCPU     := 1
LOCAL nStep    := 1
LOCAL oLocator

   oLocator := CreateObject( "wbemScripting.SwbemLocator" )
   oWMI := oLocator:ConnectServer()

   FOR EACH oProc IN oWmi:ExecQuery( "SELECT * FROM Win32_Processor" )
      IF IsWinNT() .AND. !IsWinXPHome()
         nCPU := MAX( nCPU, oProc:NumberOfCores )
         nCPU := MAX( nCPU, oProc:NumberOfLogicalProcessors )
      ENDIF
   NEXT

   oWMI := NIL
   oLocator := NIL

RETURN nCPU

*+--------------------------------------------------------------------
*+
*+    Static Function IsWinXPHome()
*+
*+    Called from ( mcpu.prg )   1 - static function checkcpu()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION IsWinXPHome()

LOCAL AVER := WinVersion()
RETURN "Home" $ AVER[ 4 ]

*+--------------------------------------------------------------------
*+
*+    Static Procedure OnDummy()
*+
*+    Called from ( mcpu.prg )   1 - static function getprocessaffinitymask()
*+                                   1 - static function setprocessaffinitymask()
*+
*+--------------------------------------------------------------------
*+
STATIC PROCEDURE OnDummy()

LOCAL iMax    := PCOUNT()
LOCAL cString := ""
LOCAL i
LOCAL lDebug  := .T.

   IF lDebug = .T.

      FOR i := 1 TO iMax - 1
         cString += Var2Char( PValue( i ) ) + CHR( 9 )
      NEXT
      cString += Var2Char( PValue( iMax ) )

      SET CONSOLE OFF
      SET ALTER ON

      ? cString

      SET ALTER OFF
      SET CONSOLE ON

   ENDIF
RETURN

*+--------------------------------------------------------------------
*+
*+    Static Function VAR2CHAR()
*+
*+    Called from ( mcpu.prg )   2 - static procedure ondummy()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION VAR2CHAR( cIn )

LOCAL cOut := hb_valToExp( cIn )
RETURN STRTRAN( cOut, '"', '' )

*+--------------------------------------------------------------------
*+
*+    Static Function RandomInt()
*+
*+    Called from ( mcpu.prg )   1 - static function paint_background_window()
*+                                   2 - static function randpoint()
*+                                   3 - static function randcolor()
*+
*+--------------------------------------------------------------------
*+
STATIC FUNCTION RandomInt( nMin, nMax )

LOCAL nRet  := 0
LOCAL nRand := RANDOM( nMax )

   nRet := INT( ROUND( nRand, 0 ) )

RETURN nRet

//
//
//

*+ EOF: MCPU.PRG